import java.awt.swing.*;
import java.awt.swing.event.*;
import java.awt.swing.text.*;
import java.awt.swing.border.*;
import java.awt.accessibility.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.applet.*;
import java.net.*;
import TicTacToe;
import HtmlPanel;

/**
 * Meng project
 *
 * Using games to explore SWING components. MengGame creates 2 tabbedpanels with 
 * a different TicTacToe level game to demonstrate different features of SWING.
 * 
 */
public class MengGame extends JPanel implements ActionListener
{
    // This
    MengGame game;

	//Icons

	ImageIcon HelpIcon = new ImageIcon("images\\help.gif");
	ImageIcon DukeWaveIcon = new ImageIcon("images\\dukeWave.gif");
	ImageIcon DukeSnoozeIcon = new ImageIcon("images\\dukeSnooze.gif");
	ImageIcon DukeMagnifyIcon = new ImageIcon("images\\dukeMagnify.gif");
	ImageIcon DukeMagnifySmallIcon = new ImageIcon("images\\dukeMagnifySmall.gif");
	ImageIcon DukeWaveRedIcon = new ImageIcon("images\\dukeWaveRed.gif");
	ImageIcon DukeWaveSmallIcon = new ImageIcon("images\\dukeWaveSmall.gif");
	ImageIcon SwingIcon = new ImageIcon("images\\swing.small.gif");
	ImageIcon TicTacToeIcon = new ImageIcon("images\\tictactoe.gif");

	// default variables
	static final byte SIMPLE = 0;
	static final byte FANCY = 1;

    // The Frame
    public static JFrame frame;

    // The panels used in the demo
    public TicTacToe tictactoePanel;
    public TicTacToe tictactoePanel2;
  	public JMenu file, landf;

    // Some components used in the demo
    public JTabbedPane tabbedPane;
    public TabPlacementChanger tabPlacement;

	public MengGame() {
		
		tabbedPane = new JTabbedPane();

		tictactoePanel = makeTicTacToePanel("TicTacToe");
		tabbedPane.addTab("TicTacToe-Simple",TicTacToeIcon,tictactoePanel, "Tic Tac Toe Game");
		tabbedPane.setSelectedIndex(0);

		tictactoePanel2 = makeTicTacToePanel2("Fancy TicTacToe");

		tabbedPane.addTab("TicTacToe-Fancy", TicTacToeIcon, tictactoePanel2, "Tic Tac Toe game");

		setLayout(new GridLayout(1,0));
		add(tabbedPane);

		// Add Tab change listener
		createTabListener();
	}

    /**
     * Tab Listener
     */
    void createTabListener() {

	// add listener to know when we've been shown
        ChangeListener changeListener = new ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                JTabbedPane tab = (JTabbedPane) e.getSource();
                int index = tab.getSelectedIndex();
                Component currentPage = tab.getComponentAt(index);
//				RepaintManager repaintManager = 
 //                   RepaintManager.currentManager(frame);
//
	//			if(!repaintManager.isDoubleBufferingEnabled()) {
	//			  repaintManager.setDoubleBufferingEnabled(true);
	//			}

                if(currentPage == tictactoePanel) {
					landf.setEnabled(false);
					tictactoePanel.setOptions(false);
					try {				
						UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
						SwingUtilities.updateComponentTreeUI(frame);
					} catch (UnsupportedLookAndFeelException exc) {
						System.err.println("Unsupported LookAndFeel: Metal");
					} catch (IllegalAccessException iexc) {
						System.err.println("IllegalAccessException LookAndFeel: Metal");
					} catch (InstantiationException inexc) {
						System.err.println("InstanticationException LookAndFeel: Metal");
					} catch (ClassNotFoundException cexc) {
						System.err.println("ClassNotFoundException LookAndFeel: Metal");
					}

				} else if (currentPage == tictactoePanel2) {
					landf.setEnabled(true);
					tictactoePanel2.setOptions(true);
				}
			}
		};
		tabbedPane.addChangeListener(changeListener);
	}


	protected TicTacToe makeTicTacToePanel(String text) {

		TicTacToe TTTGame = new TicTacToe(SIMPLE);
		TTTGame.setOptions(false);
		
        return (TicTacToe) TTTGame;
	}

	protected TicTacToe makeTicTacToePanel2(String text) {

		TicTacToe TTTGame = new TicTacToe(FANCY);
		
        return (TicTacToe) TTTGame;
	}

	private JMenuBar createMenuBar() {
		JMenuBar menuBar = new JMenuBar();
		JMenuItem item;
		ButtonGroup lanfGroup = new ButtonGroup();

		/** create file menu */

		file = new JMenu ("File");
		file.setMnemonic ('F');

		file.add(item = new JMenuItem("About MengGame", DukeMagnifySmallIcon));
		item.setMnemonic('A');
		item.addActionListener (new ActionListener() {
			public void actionPerformed (ActionEvent e) {
				doAboutMengGame();
			}
		});

		file.add (item = new JMenuItem ("Quit", DukeWaveSmallIcon));
		item.setMnemonic ('Q');
		item.setActionCommand("Quit");
		item.addActionListener(this);


		/** create Look & Feel Menu */
		landf = new JMenu ("Look & Feel");
		landf.setMnemonic ('L');
		landf.add (item = new JRadioButtonMenuItem ("Cross Platform"));
		item.setMnemonic ('C');
		item.setActionCommand("Cross");
		item.addActionListener(this);
		lanfGroup.add(item);

		landf.add (item = new JRadioButtonMenuItem ("Windows"));
		item.setMnemonic ('W');
		item.setActionCommand("Windows");
		item.addActionListener(this);
		lanfGroup.add(item);

		landf.add (item = new JRadioButtonMenuItem ("Motif"));
		item.setMnemonic ('t');
		item.setActionCommand("Motif");
		item.addActionListener(this);
		landf.add(new JSeparator());
		lanfGroup.add(item);
				
        tabPlacement = new TabPlacementChanger();
        landf.add(tabPlacement);
		tabPlacement.setEnabled(true);

		menuBar.add(file);
		menuBar.add(landf);
				
		return menuBar;
	}


	void doAboutMengGame() {
		// Create JDialog named 'dialog'
		final JDialog dialog = new JDialog ();

		dialog.addWindowListener(new WindowAdapter() {
		  public void windowClosing(WindowEvent e) {dialog.dispose();}
		});
//		JLabel  lab  = new JLabel ("Meng Game version 1.0", JLabel.CENTER);
//		dialog.getContentPane().add (lab, BorderLayout.NORTH);

		HtmlPanel htmlPanel = new HtmlPanel();
		dialog.getContentPane().add (htmlPanel, BorderLayout.CENTER);

		JButton butt = new JButton ("Okay");
		dialog.getContentPane().add (butt, BorderLayout.SOUTH);

		butt.addActionListener (new ActionListener () {
		  public void actionPerformed(ActionEvent e) {
			dialog.setVisible(false);
			dialog.dispose();
		  }
		});
		dialog.setSize (400, 500);
		dialog.setVisible(true);
	}

    public void actionPerformed(java.awt.event.ActionEvent e) {

		String command;
		int move=0;

		command = e.getActionCommand();

		if (command.equals("Quit")) {
			System.out.println("Quit");
			System.exit(0);
			return;
		} else if (command.equals("Mac")) {
			try {
		//		String PClandf = UIManager.getSystemLookAndFeelClassName();
				
				UIManager.setLookAndFeel("java.awt.swing.plaf.mac.MacLookAndFeel");
				SwingUtilities.updateComponentTreeUI(frame);
			} catch (UnsupportedLookAndFeelException exc) {
				System.err.println("Unsupported LookAndFeel: Mac");
			} catch (IllegalAccessException iexc) {
				System.err.println("IllegalAccessException LookAndFeel: Mac");
			} catch (InstantiationException inexc) {
				System.err.println("InstanticationException LookAndFeel: Mac");
			} catch (ClassNotFoundException cexc) {
				System.err.println("ClassNotFoundException LookAndFeel: Mac");
			}

			return;
		} else if (command.equals("Cross")) {
			try {				
				UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
				SwingUtilities.updateComponentTreeUI(frame);
			} catch (UnsupportedLookAndFeelException exc) {
				System.err.println("Unsupported LookAndFeel: Metal");
			} catch (IllegalAccessException iexc) {
				System.err.println("IllegalAccessException LookAndFeel: Metal");
			} catch (InstantiationException inexc) {
				System.err.println("InstanticationException LookAndFeel: Metal");
			} catch (ClassNotFoundException cexc) {
				System.err.println("ClassNotFoundException LookAndFeel: Metal");
			}

			return;
		} else if (command.equals("Motif")) {
			
			try {				
				UIManager.setLookAndFeel("java.awt.swing.plaf.motif.MotifLookAndFeel");
				SwingUtilities.updateComponentTreeUI(frame);
			} catch (UnsupportedLookAndFeelException exc) {
				System.err.println("Unsupported LookAndFeel: Motif");
			} catch (IllegalAccessException iexc) {
				System.err.println("IllegalAccessException LookAndFeel: Motif");
			} catch (InstantiationException inexc) {
				System.err.println("InstanticationException LookAndFeel: Motif");
			} catch (ClassNotFoundException cexc) {
				System.err.println("ClassNotFoundException LookAndFeel: Motif");
			}

			return;
		} else if (command.equals("Windows")) {
			String syslandf = UIManager.getSystemLookAndFeelClassName();
//
			try {
				UIManager.setLookAndFeel("java.awt.swing.plaf.windows.WindowsLookAndFeel");
				SwingUtilities.updateComponentTreeUI(frame);
			} catch (UnsupportedLookAndFeelException exc) {
				System.err.println("Unsupported LookAndFeel: Windows");
			} catch (IllegalAccessException iexc) {
				System.err.println("IllegalAccessException LookAndFeel: Windows");
			} catch (InstantiationException inexc) {
				System.err.println("InstanticationException LookAndFeel: Windows");
			} catch (ClassNotFoundException cexc) {
				System.err.println("ClassNotFoundException LookAndFeel: Windows");
			}
			return;
		} 
    }
    
   class TabPlacementChanger extends JMenu implements ItemListener {
       JRadioButtonMenuItem topRb, leftRb, rightRb, bottomRb;

       public TabPlacementChanger() {
           super("Tab Placement");

           ButtonGroup tabGroup = new ButtonGroup();

           topRb = (JRadioButtonMenuItem)add(new JRadioButtonMenuItem("Top"));
	   topRb.getAccessibleContext().setAccessibleDescription("Position the TabbedPane on the top of the window");
           topRb.setSelected(true);
           topRb.addItemListener(this);
           tabGroup.add(topRb);
        
           leftRb = (JRadioButtonMenuItem)add(new JRadioButtonMenuItem("Left"));
	   leftRb.getAccessibleContext().setAccessibleDescription("Position the TabbedPane on the left of the window");
           leftRb.addItemListener(this);
           tabGroup.add(leftRb);

           bottomRb = (JRadioButtonMenuItem)add(new JRadioButtonMenuItem("Bottom"));
	   bottomRb.getAccessibleContext().setAccessibleDescription("Position the TabbedPane on the bottom of the window");
           bottomRb.addItemListener(this);
           tabGroup.add(bottomRb);

           rightRb = (JRadioButtonMenuItem)add(new JRadioButtonMenuItem("Right"));
	   rightRb.getAccessibleContext().setAccessibleDescription("Position the TabbedPane on the right of the window");
           rightRb.addItemListener(this);
           tabGroup.add(rightRb);
        }

	public void itemStateChanged(ItemEvent e) {
	    JRadioButtonMenuItem rb = (JRadioButtonMenuItem) e.getSource();
            if (rb.isSelected()) {
                String selected = rb.getText();
                int placement;
                if (selected.equals("Top")) {
                    placement = JTabbedPane.TOP;
                } else if (selected.equals("Left")) {
                    placement = JTabbedPane.LEFT;
                } else if (selected.equals("Bottom")) {
                    placement = JTabbedPane.BOTTOM;
                } else {
                    placement = JTabbedPane.RIGHT;
                }
                tabbedPane.setTabPlacement(placement);
                tabbedPane.validate();
            }
        }
        public void setEnabled(boolean enabled) {
            super.setEnabled(enabled);
            if (!enabled) {
                topRb.setSelected(true);
            } else {
                int placement = tabbedPane.getTabPlacement();
                switch(placement) {
                  case JTabbedPane.TOP:
                      topRb.setSelected(true);
                      break;
                  case JTabbedPane.LEFT:
                      leftRb.setSelected(true);
                      break;
                  case JTabbedPane.BOTTOM:
                      bottomRb.setSelected(true);
                      break;
                  case JTabbedPane.RIGHT:
                      rightRb.setSelected(true);
                      break;
                  default:
                }
            }
        }
   }

   private void landfSetOption(boolean set) {
	   landf.setEnabled(set);
   }

    public static void main(String[] args) {
		MengGame game;

        /*
         * Create a window.  Use JFrame since this window will include 
         * lightweight components.
         */
        frame = new JFrame("Games usings Swing");
		// Force SwingSet to come up in the Cross Platform L&F
		try {
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
		// If you want the System L&F instead, comment out the above line and
		// uncomment the following:
		//	UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception exc) {
			System.err.println("Error loading L&F: " + exc);
		}

        WindowListener l = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
        };
        frame.addWindowListener(l);

        frame.getContentPane().add("Center", game=new MengGame());
		JMenuBar menuBar;

		menuBar = game.createMenuBar();
		frame.setJMenuBar(menuBar);
		game.landfSetOption(false); //set off look and feel option 

        frame.setSize(400, 400);
        frame.show();
    }
}


           